#[doc = "Register `PWR_BG_TRIM3` reader"]
pub struct R(crate::R<PWR_BG_TRIM3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PWR_BG_TRIM3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PWR_BG_TRIM3_SPEC>> for R {
    fn from(reader: crate::R<PWR_BG_TRIM3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PWR_BG_TRIM3` writer"]
pub struct W(crate::W<PWR_BG_TRIM3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PWR_BG_TRIM3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PWR_BG_TRIM3_SPEC>> for W {
    fn from(writer: crate::W<PWR_BG_TRIM3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `INL_TRIM_IMO` reader - IMO Irefgen nonlinear current trim for curvature correction."]
pub struct INL_TRIM_IMO_R(crate::FieldReader<u8, u8>);
impl INL_TRIM_IMO_R {
    pub(crate) fn new(bits: u8) -> Self {
        INL_TRIM_IMO_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for INL_TRIM_IMO_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INL_TRIM_IMO` writer - IMO Irefgen nonlinear current trim for curvature correction."]
pub struct INL_TRIM_IMO_W<'a> {
    w: &'a mut W,
}
impl<'a> INL_TRIM_IMO_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x07) | (value as u32 & 0x07);
        self.w
    }
}
#[doc = "Field `INL_CROSS_IMO` reader - IMO Irefgen INL cross-over point control for centering curve at 30C."]
pub struct INL_CROSS_IMO_R(crate::FieldReader<u8, u8>);
impl INL_CROSS_IMO_R {
    pub(crate) fn new(bits: u8) -> Self {
        INL_CROSS_IMO_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for INL_CROSS_IMO_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INL_CROSS_IMO` writer - IMO Irefgen INL cross-over point control for centering curve at 30C."]
pub struct INL_CROSS_IMO_W<'a> {
    w: &'a mut W,
}
impl<'a> INL_CROSS_IMO_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 3)) | ((value as u32 & 0x0f) << 3);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:2 - IMO Irefgen nonlinear current trim for curvature correction."]
    #[inline(always)]
    pub fn inl_trim_imo(&self) -> INL_TRIM_IMO_R {
        INL_TRIM_IMO_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bits 3:6 - IMO Irefgen INL cross-over point control for centering curve at 30C."]
    #[inline(always)]
    pub fn inl_cross_imo(&self) -> INL_CROSS_IMO_R {
        INL_CROSS_IMO_R::new(((self.bits >> 3) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:2 - IMO Irefgen nonlinear current trim for curvature correction."]
    #[inline(always)]
    pub fn inl_trim_imo(&mut self) -> INL_TRIM_IMO_W {
        INL_TRIM_IMO_W { w: self }
    }
    #[doc = "Bits 3:6 - IMO Irefgen INL cross-over point control for centering curve at 30C."]
    #[inline(always)]
    pub fn inl_cross_imo(&mut self) -> INL_CROSS_IMO_W {
        INL_CROSS_IMO_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Bandgap Trim Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pwr_bg_trim3](index.html) module"]
pub struct PWR_BG_TRIM3_SPEC;
impl crate::RegisterSpec for PWR_BG_TRIM3_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [pwr_bg_trim3::R](R) reader structure"]
impl crate::Readable for PWR_BG_TRIM3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pwr_bg_trim3::W](W) writer structure"]
impl crate::Writable for PWR_BG_TRIM3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PWR_BG_TRIM3 to value 0"]
impl crate::Resettable for PWR_BG_TRIM3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
